/*
    afs7-server lite
		Copyright(C) 2013-2014 Tomokazu Matsuo.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <windows.h>
#include <sstream>

#include "afs_lite.h"


using namespace std;

bool afs_serv::create (void) {
	if(isopen()) {		// 쐬Oɕׂ 
#ifdef DEBUG
		MessageBox(0, "Double open!!", "[afs] auto2422drop" , MB_OK);
#endif
		return false;
	}

	char pid[64];
	char servname[64];
	char *pserv = servname;

	sprintf(pid, "afs7_%lu", GetCurrentProcessId());

	// PID 10i\ĹAŌ̌ȊO0͏
	for(char const *it=pid; *it !=0; it++) {
		char c = *it;
		if(c != '0' || it[1] == 0) {
			*(pserv++) = c;
		}
	}
	*pserv = 0;

	//MessageBox(0, ss_servname.str().c_str(), "[afs] auto2422drop" , MB_OK);
	
	hmap = CreateFileMapping(INVALID_HANDLE_VALUE, 0, PAGE_READWRITE, 
		0, Share_size, servname);

	if(!isopen()) {
#ifdef DEBUG
		stringstream ss;
		ss << "Error: CreateFileMapping: errcode=" << GetLastError() << endl;
		MessageBox(0, ss.str().c_str(), "[afs] auto2422drop" , MB_OK);
#endif
		return false;	// JȂG[ 
	}

	view = reinterpret_cast<unsigned char *>(
		MapViewOfFile(hmap, FILE_MAP_WRITE, 0, 0, Share_size));
	if(view == 0) {
		close();
#ifdef DEBUG
		stringstream ss;
		ss << "Error: MapViewOfFile: errcode=" << GetLastError() << endl;
		MessageBox(0, ss.str().c_str(), "[afs] auto2422drop" , MB_OK);
#endif
		return false;
	}

	status_list.clear();	// Xe[^XXg̐ݒ

	return true;
}

bool afs_serv::close (void) {
	if(view != 0) {
		if(UnmapViewOfFile(view) == FALSE)
			return false;
		else
			view = 0;
	}

	if(hmap != 0) {
		if(CloseHandle(hmap) == FALSE)
			return false;
		else
			hmap = 0;
	}
	
	return true;
}

void	afs_serv::set_init (unsigned int startframe, unsigned int n_frame)
{
	if(!isopen())
		return;

	*reinterpret_cast<int32_t *>(view+Offset_startfrm) = startframe; 
	*reinterpret_cast<int32_t *>(view+Offset_share_n) = 0; 

	if(n_frame > status_list.size()) {
		status_list.resize(n_frame);
		*reinterpret_cast<int32_t *>(view+Offset_frame_n) = status_list.size();
	}

	// |C^ݒ
	*reinterpret_cast<unsigned char **>(view+Offset_statusptr) = &(status_list[0]); 

	set_error(0);
}


void	afs_serv::set_shift (unsigned int frameno, unsigned char shift_bit)
{
	if(!isopen())
		return;

	// KvɉĔ{Xŗ̈g
	while(status_list.size() <= frameno) {
		status_list.resize(status_list.size()*2+1);
		*reinterpret_cast<int32_t *>(view+Offset_frame_n) = status_list.size();
	}

	status_list[frameno] = shift_bit;

	// |C^ݒ
	*reinterpret_cast<unsigned char **>(view+Offset_statusptr) = &(status_list[0]); 
}

void	afs_serv::set_error (int error) 
{
	if(!isopen())
		return;
	*reinterpret_cast<int32_t *>(view+Offset_share_err) = error; 
}

