/*
    afs7-server lite
		Copyright(C) 2013-2014 Tomokazu Matsuo.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <windows.h>
#include <vector>


class afs_serv {
private:
    // 萔 
    static DWORD const Share_size = 0x18;
    static int const Offset_share_n = 0x0;
    static int const Offset_share_err = 0x4;
    static int const Offset_frame_n = 0x8;
    static int const Offset_startfrm = 0xc;
    static int const Offset_statusptr = 0x10;

    // nh 
    HANDLE hmap;
    unsigned char *view;

    std::vector<unsigned char> status_list;	// afs 肵et[̏ 

public:
    bool isopen (void) { return hmap != 0; }

    bool create (void);
    bool close (void);
	
    unsigned char & operator [] (std::size_t sz) { return view[sz]; }

    afs_serv (void) { hmap = 0; view = 0; }
    ~afs_serv () { if(isopen()) close(); }

    // accessor
    void set_init (unsigned int startframe, unsigned int n_frame = 0);
    void set_shift (unsigned int frameno, unsigned char shift_bit);
    void set_error (int error);

};

