/* emacs: -*- mode: c-mode; c-basic-offset:4; comment-column: 40 -*- */
/*
       	auto2422drop plugin
		Copyright(C) 2013-2014 Tomokazu Matsuo.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <cassert>
#include <cmath>
#ifndef APIHDR_AVIUTL_FILTER_H
#define APIHDR_AVIUTL_FILTER_H
#include "filter.h"
#endif
#include <map>

#define arrayof(x) sizeof(x)/sizeof(*x)

#define TRACK_N 4
#define CHECK_N 8
#define AVIUTL_CALLBACK		// ֐̎gp@̃̂߂̋`

/* hbvXgZbg֐ */
void clear_droplists (void);
void clear_allstats (void);

/* default ݒl */
extern int track_default[TRACK_N];
extern int check_default[CHECK_N];


class auto2422_setting {
    FILTER *pfil;

    int trackref (std::size_t idx) const
    {
	if(pfil == 0) {
	    assert(idx < arrayof(track_default));
	    return track_default[idx];
	}

	assert(pfil->track_n >= 0 && idx < static_cast<std::size_t>(pfil->track_n));
	if(pfil->track != 0)
	    return pfil->track[idx];
	else
	    return track_default[idx];
    }

    int checkref (std::size_t idx) const {
	if(pfil == 0) {
	    assert(idx < arrayof(check_default));
	    return check_default[idx];
	}

	assert(pfil->check_n >= 0 && idx < static_cast<std::size_t>(pfil->check_n));
	if(pfil->check != 0)
	    return pfil->check[idx];
	else
	    return check_default[idx];
    }

public:
    /*  */
    auto2422_setting (void) {pfil = 0;}

    /* V FILTER ̋L/(=0̎) */
    FILTER *set (FILTER * pf) { auto ret=pfil; pfil = pf; return ret;} 

    /* ݒl̎擾 */
    double sqsumlim1 (void) const { return std::pow(10,trackref(0)/10.0); }
    double sqsumlim2 (void) const { return std::pow(10,trackref(1)/10.0); }
    double ssimlim (void) const { return trackref(2)/100.0; }
    int finescroll_separation (void) const { return trackref(3); }
    int globalscroll_separation (void) const { return 0 /*trackref(4)*/ ; }

    bool keep_droppoint_strongly (void) const { return checkref(2) != 0; }
    bool keep_droppoint_onpanic (void) const { return checkref(5) != 0; }
    bool detect_finescroll (void) const { return finescroll_separation() != 0; }
    bool detect_globalscroll (void) const { return globalscroll_separation() != 0; }
    bool call_predeint (void) const { return checkref(3) != 0; }
    bool use_afsvfr (void) const { return checkref(4) != 0; }
    bool dont_drop (void) const { return checkref(6) != 0; }
    bool show_judge (void) const { return checkref(7) != 0; }
};

bool init_dlgpart (FILTER_DLL *fdll);

extern "C" int dbprintf (char const *format, ...);
