/* emacs: -*- mode: c-mode; c-basic-offset:4; comment-column: 40 -*- */
/*
       	auto2422drop plugin
		Copyright(C) 2013-2014 Tomokazu Matsuo.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <cstdio>
#include <windows.h>
#include "auto2422.h"

// ݒ荀
// ڐAwb_ TRACK_N, CHECK_N !
static TCHAR const *track_name[] = {
    "MSE", 	// ̒l݂̂œF\Ȃ: raw default=0.00004 ~ -44dB
    "MSE",	// ssim ĂsvF肷: raw default=0.0006 ~ -32dB
    "SSIM",		// łȂR} ssim ̍ől (block=64, scaling=1):
 			// raw default: 0.87
    "",		// XN[m̕, 0:mȂ, 1~: n~nɕ
                        // ꕔłΌm
//    "擮",  	// XN[m̕, 0:mȂ, 1~: n~nɕ
//                        // ꕔłΌm
};

static TCHAR const *check_name[] = {
    "ݒ胊Zbg",
    "LbV",
    "AۑD",	// Ahbv^C~O̕ۑD悷
    "Interace\"\"őO",	//  OƂăC^[[XĂԂ?
    "VFRΉ(Field ShiftU)",	// afs7 Ɠ̕@ VFR 
    "pjbNɎۑ",
    "ҏW͔肵Ȃ", 
    "\\ (p)", 
};
int const Button_reset = 0;
int const Button_clearstats = 1;

static int track_s[] { -60, -60, 0, 0, /* 0, */};
static int track_e[] { 0, 0, 100, 9, /* 9, */ };

// ݒl
int track_default[] { -44, -32, 87, 2, /* 0, */ };
int check_default[] { -1, -1, 0, 1, 1, 0, 0, 0, };


static BOOL update_check(FILTER *fp,int status)
{
    auto2422_setting set;
    set.set(fp);

    if(fp == 0 || fp->track == 0)
	return FALSE;

    clear_droplists();		// ݒ肪ς̂Ŕj

    // l͈̔͂BȂΏI
    if(fp->track[0] <= fp->track[1])
	return TRUE;

    // ͈͊OꍇAύXꂽ␳
    switch(status) {
    case FILTER_UPDATE_STATUS_TRACK+0:
	fp->track[0] = fp->track[1];
	break;

    case FILTER_UPDATE_STATUS_TRACK+1:
	fp->track[1] = fp->track[0];
	break;

    // ǂ炩킩Ȃ͂Ƃ肠
    default:
	int v1 = static_cast<int>(std::floor((fp->track[0]+fp->track[1])/2.0)); 
	int v2 = static_cast<int>(std::ceil((fp->track[0]+fp->track[1])/2.0)); 
	fp->track[0] = v1;
	fp->track[1] = v2;
	break;
    }

    // ݒXV
    fp->exfunc->filter_window_update(fp);

    return TRUE;
}

int last_total_frame=0;

static BOOL func_WndProc (HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam,void *editp, FILTER *fp )
{
    switch(msg) {
    case WM_FILTER_UPDATE:
	if(last_total_frame == fp->exfunc->get_frame_n(editp))
	    return FALSE;/* t[ɕύXȂ΃LbṼNA͕sv */

	/* ɗƂƂ̓t[ɕύX̂ŁA*/
	/*  WM_FILTER_FILE_UPDATE ɍsLbV */

    case WM_FILTER_FILE_OPEN:
    case WM_FILTER_FILE_UPDATE:
	clear_allstats();
	last_total_frame = fp->exfunc->get_frame_n(editp);
	return TRUE;


    case WM_COMMAND:
	// ݒ胊Zbg{^̏
	if(wParam == MID_FILTER_BUTTON+Button_reset) {
	    memcpy(fp->track, fp->track_default, sizeof(fp->track[0])*fp->track_n);
	    memcpy(fp->check, fp->check_default, sizeof(fp->check[0])*fp->check_n);
	    fp->exfunc->filter_window_update(fp);

	    return TRUE;
	}

	if(wParam == MID_FILTER_BUTTON+Button_clearstats) {
	    clear_allstats();
	    fp->exfunc->filter_window_update(fp);
	    return TRUE;
	}
    }

    return FALSE;		// ĂȂ
}

// _CAOp̐ݒǉ
bool init_dlgpart (FILTER_DLL *fil)
{
    fil->flag |= FILTER_FLAG_WINDOW_SIZE ;
    fil->x = 0 | FILTER_WINDOW_SIZE_ADD;
    fil->y = 40 | FILTER_WINDOW_SIZE_ADD;		// OI combo p̒ǉTCY

    // XCh̐ݒ
    fil->track_n = arrayof(track_name);
    fil->track_name = const_cast<TCHAR **>(track_name); // FILTER  const Ȃ̂ŎdȂ
    fil->track_default = track_default;
    fil->track_s = track_s;
    fil->track_e = track_e;

    // `FbN̐ݒ
    fil->check_n = arrayof(check_name);
    fil->check_name = const_cast<TCHAR **>(check_name); // FILTER  const Ȃ̂ŎdȂ
    fil->check_default = check_default;

    // XVmF֐̐ݒ
    fil->func_update = update_check;
    fil->func_WndProc = func_WndProc;

    return 0;
}

#undef dbprintf
// debug printf
int dbprintf (char const *format, ...)
{
    va_list list;
    char buf[65537];
    int r;
	
    va_start(list, format);

    r = vsprintf(buf, format, list);
    OutputDebugString(buf);	
	
    va_end(list);

    return r;
}
