/* emacs: -*- mode: c-mode; c-basic-offset:4; comment-column: 40 -*- */
/*
       	auto2422drop plugin
		Copyright(C) 2013-2014 Tomokazu Matsuo.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include	<windows.h>
#include	<fstream>
#include	<sstream>
#include	<iostream>
#include	<memory>
#include	<map>
#include	<algorithm>
#include	<stdexcept>
#include        <cassert>
#include        <type_traits>

#ifdef _OPENMP
#include <omp.h>
#endif

#ifndef APIHDR_AVIUTL_FILTER_H
#define APIHDR_AVIUTL_FILTER_H
#include	"filter.h"
#endif
#include	"afs_lite.h"
#include        "auto2422.h"

// training log o (}N؂ւ͉u)
// #define TRAIN
// #define DEBUG_AFS
// #define DEBUG_CACHE		// dropcache f[^o
// #define DEBUG_DROP		// drop 蕔`FbN
// #define DEBUG_TIME		// vZԊmF
//#define DEBUG_MSG		// fobOpbZ[Wo

#if !defined(DEBUG) && !defined(DEBUG_MSG)
#  define dbprintf(...)
#endif


#define LOG_PATH ".\\"

class YC_ptr {
    PIXEL_YC *p;

public:
    YC_ptr (void) { p=0; }
    YC_ptr (PIXEL_YC *pYC) { p=pYC;}
    YC_ptr (YC_ptr & yc) { p=yc.p; yc.p=0; }
    YC_ptr & operator = (YC_ptr & yc) { if(p) delete[] p; p=yc.p; yc.p=0; return *this; }

    virtual ~YC_ptr() { if(p) delete[] p; }

    PIXEL_YC *get (void) const { return p; }
    operator PIXEL_YC *() { return p; }
};

AVIUTL_CALLBACK static BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip );
AVIUTL_CALLBACK static BOOL func_is_saveframe (FILTER *fp, void *editp, int saveno, int frame, 
					       int fps, int edit_flag, int inter);

AVIUTL_CALLBACK static BOOL func_save_start (FILTER *fp,int s,int e,void *editp );
AVIUTL_CALLBACK static BOOL func_save_end (FILTER *fp,void *editp );

FILTER_DLL filter = {
    FILTER_FLAG_INTERLACE_FILTER|FILTER_FLAG_EX_INFORMATION,
    0,0,
    (TCHAR *)"2422Ԉ",
    0,NULL,NULL,
    NULL,NULL,
    0,NULL,NULL,
    &func_proc,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,NULL,
    NULL,
    0,
    (TCHAR *)"2422Ԉ $Rev: 446 $ (C) 2013-2014 Tomokazu Matsuo.",
    &func_save_start, &func_save_end,
    NULL,NULL,NULL,
    NULL,
    &func_is_saveframe,
    0,
    0,
    0,
    0,
    {0,0}
};


//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    init_dlgpart(&filter);
    return &filter;
}

// ݒ
auto2422_setting conf;		// aviutl ̕ł邱Ƃ̂łݒ
                                // aviutl Ă΂邽тɁAL FILTER * 
                                // conf.set() ɓnĐݒXVBl߂lƂ
                                // Ԃ̂ŁAL͈͂𔲂邲Ƃɏ߂B
  
char predeint_name[] = ""; // OpC^[[XtB^
/*
     : Ȃ͊SɂȂȂ邪24fňꕔ𑜓xቺ
     24fps: ebvShiftŏȂȂcB(C^[[X2ƕp)
     }jA24fps: Ԉ^C~OpȂ̂ŊԈ~X蓾B
                    ܂Ȃ͎cB60iebv60i->24\
     : tB[hVtg VFR 邽ߎgpłȂB
*/

double const guardband_up = 0.03;
double const guardband_down = 0.03;
double const guardband_left = 0.03;
double const guardband_right = 0.03;

struct gband_t {
    int v[4];

    void set (int xw, int yh) { 
	v[0]=yh*guardband_up;
	v[1]=yh*guardband_down;
	v[2]=xw*guardband_left;
	v[3]=xw*guardband_right;
}

public:
    gband_t (void) { for(int i=0; i<4; i++) v[i]=-1; }

    int u (void) const { return v[0]; }
    int d (void) const { return v[1]; }
    int l (void) const { return v[2]; }
    int r (void) const { return v[3]; }
} gband;

// ܂Őݒ


FILTER_PROC_INFO last_info;
FILTER *predeint = 0;
bool predeint_checked = false;

static std::ofstream ofs_timecode;
static int savetop;
static int savebot;
static bool issaving = false;

// hbvt[̃Xg
std::map<int, bool> droplist;
// ̃Xg
std::map<int, char> sqsumlist;
std::map<int, char> ssimlist;
std::map<int, char> scrolllist;	// XN[m
std::map<int, char> paniclist;	// pjbNhbv(SfrقȂ̂ɖɊԈ)ʒu

afs_serv afsout;



// OC^[XT
static FILTER *get_predeint (FILTER *fp) {
    FILTER *pfil;
    int i = 0;

    do {
	pfil = reinterpret_cast<FILTER *>(fp->exfunc->get_filterp(i));
	if(pfil) {
	    if(strcmp(pfil->name, predeint_name) == 0) 
		return pfil;
	}
	i++;
    } while(pfil != 0);

    MessageBox(0, "pfil is zero", "get_predeint()", MB_OK);

    return 0;
}

// \[Xt[̃[h
static BOOL load_source (FILTER *fp, FILTER_PROC_INFO *fpip) {
    PIXEL_YC	*p0;

    if(conf.call_predeint() && !predeint_checked) {
	predeint = get_predeint(fp);
	predeint_checked = true;
    }

    // predeint ĂяoȂ烍[h͔C
    if(conf.call_predeint()) {
	return predeint->func_proc(fp, fpip);
    }

    // Ȃ fpip->ycp_edit Ƀf[^͂Ń[h
    p0 = (PIXEL_YC *)fp->exfunc->get_ycp_source_cache(fpip->editp, fpip->frame, 0);

    memcpy(fpip->ycp_edit, p0, fpip->max_w * fpip->max_h * sizeof(PIXEL_YC));

    return TRUE;
}

// w̃t[(Kv)ĂԂB
PIXEL_YC *load_source_to_PIXEL_YC (int frame, FILTER *fp, 
				   void *editp, FILTER_PROC_INFO *fpip = &last_info) {
    int wmax = fpip->max_w;
    int hmax = fpip->max_h;

    /* filter_func() ɌĂяoꂽɑȂ₤-1 */
    if(wmax == 0 || hmax == 0) {
	fp->exfunc->get_frame_size(editp, &wmax, &hmax);
    }
    
    PIXEL_YC *buff = new PIXEL_YC[fpip->max_w*fpip->max_h];

    if(!conf.call_predeint()) {
	memcpy(buff, 
	       fp->exfunc->get_ycp_source_cache(fpip->editp, frame, 0),
	       fpip->max_w * fpip->max_h * sizeof(PIXEL_YC));

	return buff;
    }


    FILTER_PROC_INFO fpdummy = *fpip;
    fpdummy.ycp_edit = buff;
    fpdummy.ycp_temp = fpip->ycp_temp;
    fpdummy.frame = frame;

    /* filter_func() ɌĂяoꂽɑȂ₤-2 */
    fpdummy.max_w = wmax;
    fpdummy.max_h = hmax;
    if(fpdummy.editp == 0)
	fpdummy.editp = editp;

    load_source(fp, &fpdummy);

    return buff;
}


template <typename T_val>
inline T_val sq (T_val x) { return x*x; }

// Pxl->ʊȈՕϊ
inline long long luma (long long x) { return x; }


// XN[p Mean Square Error vZ
// Ԃl: VtgȂ̎ mse
//        ̑̌ʂ msearray, msearray_half ŕԂ
static double MSE_fineshift (PIXEL_YC const *pYC_cur, PIXEL_YC const *pYC_prev,
		      int xlow, int ylow, int xhigh, int yhigh, int max_x, int max_y,
		      double msearray[3][3], double msearray_half[3][3]) {
    long long sqsum[3][3] = {};
    long long sqsum_half[3][3] = {};

    assert(xlow >= 0 && xhigh <= max_x && ylow >= 0 && yhigh <= max_y);

    for(auto y=ylow+1; y<yhigh-1; y++) {
	for(auto x=xlow+1; x<xhigh-1; x++) {
	    auto const refi = x+y*max_x;
	    auto const refcur = pYC_cur[refi].y;
	    auto const refprv = pYC_prev[refi].y;

	    // 摜炵ĒlvZBQƐ悪قƂǓȂ̂ł𒆂ɂق͂
	    for(auto sy : {-1,0,1}) {
		for(auto sx : {-1,0,1}) {
		    sqsum[sy+1][sx+1] += sq(refcur - pYC_prev[refi-sy*max_x-sx].y);
		    sqsum_half[sy+1][sx+1] += sq(refcur - ((refprv+pYC_prev[refi-sy*max_x-sx].y)>>1));
		}		    
	    }
	}
    }

    for(auto sy=0; sy<3; sy++) {
	for(auto sx=0; sx<3; sx++) {
	    msearray[sy][sx] = static_cast<double>(sqsum[sy][sx]) / ((4096.0 * 4096.0) * ((xhigh-xlow-2)*(yhigh-ylow-2)));
	    msearray_half[sy][sx] = static_cast<double>(sqsum_half[sy][sx]) / ((4096.0 * 4096.0) * ((xhigh-xlow-2)*(yhigh-ylow-2)));
	}		    
    }
    
    return msearray_half[1][1];	// 炵 0 ̏ꍇ msearray  msearray_half l
}

// JԂ 1/2 k֐
// XN[mp
static bool shrink_pict (int const scaling_level, PIXEL_YC *pYC_dst, PIXEL_YC *pYC_src, 
			   int const src_xl, int const src_yl, int const src_xw, int const src_yw, 
			   int const dst_xl, int const dst_yl, int const max_x, int const max_y) {

    assert(src_xw>0 && 0 < src_xl && src_xl+src_xw <= max_x);
    assert(src_yw>0 && 0 < src_yl && src_yl+src_yw <= max_y);

    int dx = src_xw/2;
    int dy = src_yw/2;

    for(int y=0; y<dy; y++) {
	for(int x=src_xl; x<dx; x++) {
	    int sumy=0;
	    int sumcb=0;
	    int sumcr=0;
	    for(auto i : {0,1,max_x,max_x+1}) {
		PIXEL_YC tmp = pYC_src[src_xl+x*2+(src_yl+y*2)*max_x+i];
		sumy += tmp.y;
		sumcb += tmp.cb;
		sumcr += tmp.cr;
	    }

	    pYC_dst[(dst_yl+y)*max_x+dst_xl+x] = PIXEL_YC {
		static_cast<decltype(pYC_dst->y)>(sumy/4),
		static_cast<decltype(pYC_dst->cb)>(sumcb/4),
		static_cast<decltype(pYC_dst->cr)>(sumcr/4)};
	}
    }

    if(scaling_level>1)
	return shrink_pict(scaling_level-1, pYC_dst, pYC_dst, 
		    dst_xl, dst_yl, dx, dy, // Vɏk̈\[Xɂ
		    dst_xl+dx, dst_yl+dy,   // k̈̉Eׂɍďk
		    max_x, max_y);
    else
	return true;
}

static bool fine_scroll_detect (PIXEL_YC const *pYC_cur, PIXEL_YC const *pYC_prev,
		    int xlow, int ylow, int xhigh, int yhigh, int max_x, int max_y) {

    double mse_full[3][3];
    double mse_half[3][3];
    
    double center = MSE_fineshift(pYC_cur, pYC_prev, 
				  xlow, ylow, xhigh, yhigh, max_x, max_y,
				  mse_full, mse_half);

    for(int dy=0; dy<3; dy++) {
	for(int dx=0; dx<3; dx++) {
	    if(dx == 1 && dy == 1)
		continue;

	    // ̕ MSE  half pixel/frame ȏ̃XN[
	    if(center > mse_full[dy][dx]
	       || center > mse_half[dy][dx])
		return true;
	}
    }

    return false;
}

/*************/
static bool global_scroll_detect (PIXEL_YC const *pYC_cur, PIXEL_YC const *pYC_prev,
		    int xlow, int ylow, int xhigh, int yhigh, int max_x, int max_y) {

//    dbprintf("%s(): stub.\n", __func__);
    return false;

}


static bool scroll_detect (PIXEL_YC const *pYC_cur, PIXEL_YC const *pYC_prev,
				int xlow, int ylow, int xhigh, int yhigh, int max_x, int max_y) {
    if(conf.detect_finescroll()) {
	int sep = conf.finescroll_separation();
	auto xstep = (xhigh-xlow)/sep;
	auto ystep = (yhigh-ylow)/sep;

	bool retv=false;

	LARGE_INTEGER ctr_start;
	QueryPerformanceCounter(&ctr_start);

#pragma omp parallel for
	for(auto i=0; i<sep*sep; i++) {
	    auto xval = xlow + xstep*(i%sep);
	    auto yval = ylow + ystep*(i/sep);

	    if(fine_scroll_detect(pYC_cur, pYC_prev, xval, yval, xval+xstep, yval+ystep,
				  max_x, max_y)) {
#pragma omp atomic write
		retv=true;
	    }
	}

#ifdef DEBUG_TIME
    LARGE_INTEGER ctr_end;
    LARGE_INTEGER ctr_freq;
    QueryPerformanceCounter(&ctr_end);
    QueryPerformanceFrequency(&ctr_freq);

    std::ofstream ofs(LOG_PATH "log.txt", std::ofstream::app);

    ofs << "Time(MSE_fineshift()): " 
	<< static_cast<double>(ctr_end.QuadPart-ctr_start.QuadPart)/ctr_freq.QuadPart
	*1000 << "ms" << std::endl;
#endif

	if(retv)
	    return retv;
    }

    if(conf.detect_globalscroll()
       && global_scroll_detect(pYC_cur, pYC_prev, xlow, ylow, xhigh, yhigh, max_x, max_y))
	return true;

    return false;
}


// 摜̍ssimvZ
void ssim (double &ssimval, // Ԃl
	   int scaling,	 // k (3`5 W)
	   PIXEL_YC const *pYC_cur, PIXEL_YC const *pYC_prev, 
	   int xlow, int ylow, int xhigh, int yhigh, int max_x, int max_y) 
{
    PIXEL_YC const *pYC[2] = {pYC_cur, pYC_prev};
    long long sum0 {};
    long long sum1 {};
    long long sqsum0 {};
    long long sqsum1 {};
    long long crossmul = 0;

    assert(xlow >= 0 && xhigh <= max_x && ylow >= 0 && yhigh <= max_y);

    int sxmax = (xhigh-xlow)/scaling-1;
    int symax = (yhigh-ylow)/scaling-1;

    int xend = xlow + sxmax*scaling;
    int yend = ylow + symax*scaling;

    double scalediv = 1/static_cast<double>(scaling*scaling);

    for(int y=ylow; y<yend; y+=scaling) {
	for(int x=xlow; x<xend; x+=scaling) {
	    PIXEL_YC scaledYC[2] {};

	    for(int dy=0; dy<scaling; dy++) {
		for(int dx=0; dx<scaling; dx++) {
		    // ksNZlvZ
		    scaledYC[0].y += pYC[0][x+dx+(y+dy)*max_x].y * scalediv;
		    scaledYC[1].y += pYC[1][x+dx+(y+dy)*max_x].y * scalediv;
		}
	    }

	    // eԒlvZ
	    scaledYC[0].y *= scalediv;
	    scaledYC[1].y *= scalediv;
	    
	    sum0 += luma(scaledYC[0].y);
	    sqsum0 += sq<long long>(luma(scaledYC[0].y));
	    sum1 += luma(scaledYC[1].y);
	    sqsum1 += sq<long long>(luma(scaledYC[1].y));

	    crossmul += luma(scaledYC[0].y)*luma(scaledYC[1].y);

	}
    }


    long long sum[2] = {sum0, sum1};
    long long sqsum[2] = {sqsum0 ,sqsum1};

    const double k1 = 0.01;
    const double k2 = 0.03;
    const double c1 = sq(k1*1.0);	// dynamic range 0-1ɐKĂ̂
    const double c2 = sq(k2*1.0);	// L=1

    double avg[2];
    double sqavg[2];
    double var[2];
    double covar;
    double crossavg;

    for(int i=0; i<2; i++) {
	avg[i] = (sum[i] / 4096.0) / (sxmax) / (symax);
	sqavg[i] = sqsum[i] / (4096.0*4096.0) / (sxmax) / (symax);
	var[i] = sqavg[i] - sq(avg[i]);
    }

    crossavg = (crossmul / (4096.0*4096.0)) / (sxmax) / (symax);
	
    covar = crossavg - (avg[0]*avg[1]);

    ssimval = (2*crossavg+c1) * (2*covar+c2)
	/(sqavg[0]+sqavg[1]+c1) / (var[0]+var[1]+c2);

#if 0
    std::ofstream ofs(LOG_PATH "log.txt", std::ios_base::out | std::ios_base::app);
    ofs << "sum=" << sum[0] << " " << sum[1] 
	<< ", sqsum=" << sqsum[0] << " " << sqsum[1]
	<< ", crossmul=" << crossmul << std::endl
	<< "avg=" << avg[0] << " " << avg[1]
	<< ", crossavg=" << crossavg
	<< ", sqavg=" << sqavg[0] << " " << sqavg[1]
	<< ", var=" << var[0] << " " << var[1]
	<< ", covar=" << covar
	<< ", ssim=" << ssimval << std::endl;
#endif

    return;
}

// block čŏ ssim  block  ssim T
static void ssim_block (double &ssimval, // Ԃl
		 int scaling,	 // k (3`5 W)
		 int blocksize,	 // block ̕(kOpixel)
		 PIXEL_YC *pYC_cur, PIXEL_YC *pYC_prev, 
		 int xlow, int ylow, int xhigh, int yhigh, int max_x, int max_y) {

    int const nblks_x = (xhigh - xlow) / blocksize;
    int const nblks_y = (yhigh - ylow) / blocksize;
    int centeroff_x = ((xhigh -xlow) % blocksize) / 2;	// [Eϓ邽߂
    int centeroff_y = ((yhigh -ylow) % blocksize) / 2;	// 炵

    double ssimmin = 1;

#pragma omp parallel for reduction(min:ssimmin)
    for(auto yb=0; yb<nblks_y; yb++)
	for(auto xb = 0; xb < nblks_x; xb++) {
	double ssimcur;
	ssim(ssimcur, scaling, pYC_cur, pYC_prev,
	     xlow+centeroff_x+xb*blocksize, 
	     ylow+centeroff_y+yb*blocksize, 
	     xlow+centeroff_x+(xb+1)*blocksize, 
	     ylow+centeroff_y+(yb+1)*blocksize,
	     max_x, max_y);

	if(ssimcur < ssimmin)
	    ssimmin = ssimcur;
    }
    
    dbprintf("->ssim_block(): %g", ssimmin);
    ssimval = ssimmin;
}



// 摜̍vZ
static void diffpict (double &sqsum, double &pp, double &signalavg, 
	       double &ssimval,
	       PIXEL_YC *pYC_cur, PIXEL_YC *pYC_prev, 
	       int xlow, int ylow, int xhigh, int yhigh, int max_x, int max_y) 
{
#if 0
    std::ofstream ofs(LOG_PATH "log.txt", std::ios_base::out | std::ios_base::app);
#endif
    double diffpp = 0;
    double diffsum = 0;
    unsigned long long sigsum = 0;

    LARGE_INTEGER ctr_freq;
    LARGE_INTEGER ctr_start;
    LARGE_INTEGER ctr_ssim;
    LARGE_INTEGER ctr_end;

    QueryPerformanceCounter(&ctr_start);

#pragma omp parallel for reduction(+:sigsum) reduction(+:diffsum) reduction(max:diffpp)
    for(int y=ylow; y<yhigh; y++) {
	for(int x=xlow; x<xhigh; x++) {
	    double diffval =  (
//		(pYC_cur[x+y*max_x].cr - pYC_prev[x+y*max_x].cr)
//		(pYC_cur[x+y*max_x].cb - pYC_prev[x+y*max_x].cb)
		(pYC_cur[x+y*max_x].y - pYC_prev[x+y*max_x].y))/(4096.0);
	    sigsum += sq(pYC_cur[x+y*max_x].y + pYC_prev[x+y*max_x].y);
			
	    diffval *= diffval;
	    diffsum +=diffval;
	    if(diffpp < diffval)
		diffpp = diffval;
	}
    }

    diffsum /= (xhigh-xlow);
    diffsum /= (yhigh-ylow);
    signalavg = sigsum / (4096.0*4096.0*(xhigh-xlow)*(yhigh-ylow));
    sqsum = diffsum;
    pp = diffpp;

    QueryPerformanceCounter(&ctr_ssim);

    ssim_block(ssimval, 1, 64, pYC_cur, pYC_prev, xlow, ylow, xhigh, yhigh, 
	       max_x, max_y);

    QueryPerformanceCounter(&ctr_end);
    QueryPerformanceFrequency(&ctr_freq);

#ifdef DEBUG_TIME
    {
	std::ofstream ofs(LOG_PATH "log.txt", std::ofstream::app);

	ofs << "Time(diffpict): " 
	    << static_cast<double>(ctr_end.QuadPart-ctr_start.QuadPart)/ctr_freq.QuadPart 
	    *1000 << "ms" << std::endl;
	ofs << " SubTime(ssim): " 
	    << static_cast<double>(ctr_end.QuadPart-ctr_ssim.QuadPart)/ctr_freq.QuadPart 
	    *1000 << "ms" << std::endl;
    }
#endif

#if 0
    ofs << "diffpict(): sqsum=" << sqsum 
	<< ", pp=" << pp
	<< ", signalavg=" << signalavg
	<< ", ssim=" << ssimval
	<< std::endl;
#endif

    return;
}


int gcd (int x, int y) {
    if(x<y)
	return gcd(y,x);
		
    for(int z=(x%y); z!=0; z=(x%y)) {
	x=y;
	y=z;
    }

    return y;
}


AVIUTL_CALLBACK static BOOL func_save_start (FILTER *fp,int s,int e,void *editp ) {
    FILTER *old = conf.set(fp);

    savetop = s;
    savebot = e;

    clear_allstats();		// o͎ɂ͔ÔߊSZbg

    get_predeint(fp);

    issaving = true;

    conf.set(old);
    return TRUE;
}

AVIUTL_CALLBACK static BOOL func_save_end (FILTER *fp,void *editp ) {
    auto old = conf.set(fp);

    issaving = false;
    afsout.close();

    conf.set(old);
    return TRUE;
}



struct pict_pattern_t {
public:
    int n_ren;		// őAt[ (1~5)
    int n_pos;		// őAt[̐擪
    bool single;

    pict_pattern_t (int nren=0, int npos=0) 
    { n_ren = nren; n_pos = npos; single=true;}
};


// łAt[drop邽߂
// łAt[T֐
static pict_pattern_t find_pattern (char *picdiff_cache) {
    pict_pattern_t pat(1,0);
    int nren_cur = 1;
    int nren_max = 1;

#ifdef DEBUG
    std::ofstream ofs(LOG_PATH "log.txt", std::ios_base::out | std::ios_base::app);
    ofs << "find_pattern: picdiff_cache=";
#endif
    for(int i=0; i<5; i++) {
#ifdef DEBUG
	ofs << (int)picdiff_cache[i]<<"("<<i<<")";
#endif
	if(picdiff_cache[i]==0) {
	    nren_cur++;
	    if(nren_cur > nren_max)
		nren_max = nren_cur;
	} else
	    nren_cur = 1;
    }

#ifdef DEBUG
    ofs << ", nren_cur=" << nren_cur << ", nren_max=" << nren_max << std::endl;
#endif

    assert(nren_max >=1 && nren_max <=6); 

    switch(nren_max) {
    case 1:				// Sfr.ƂقȂ
	return pat;		// ԈȂ

    case 6:
	pat.n_ren = 5;	// Jn_0
	return pat;

    case 5:
	pat.n_ren = 5;	// Jn_01
	if(picdiff_cache[0]==1)
	    pat.n_pos = 1;
	return pat;

    case 4:
	pat.n_ren=4;
				
/*
 fr.p^[	p^[
 11112x		0001x
 122223		10001
 x12222		x1000
 2,4ԖڂŊS\
 p^[̏d͂Ȃ̂ł̂܂ܔ
*/

	if(picdiff_cache[3]==1)
	    pat.n_pos = 0;
	else if(picdiff_cache[1]==1)
	    pat.n_pos = 2;
	else
	    pat.n_pos = 1;

	return pat;

    case 3:
	pat.n_ren=3;

// fr.p^[	pat	ԈubN̐擪
// 111222	00100	3	ɂƂ͌Ԉ
// 1112xx	001xx	0
// xx1222	xx100	3
// 12223x	1001x	1
// x12223	x1001	2

	if(picdiff_cache[3]==0 && picdiff_cache[4]==0 )
	    pat.n_pos = 3;
	else if(picdiff_cache[2]==0 && picdiff_cache[3]==0 )
	    pat.n_pos = 2;
	else if(picdiff_cache[1]==0 && picdiff_cache[2]==0 )
	    pat.n_pos = 1;
	else
	    pat.n_pos = 0;
				
	return pat;

    case 2:
	pat.n_ren=2;

	bool already_found=false;
	for(int i=4; i>=0; i--) {
	    if(picdiff_cache[i]==0) {	// 납2AfrT
		pat.n_pos = i;		// DŊԈ (##### ̃oO͂ƂŏC)

		if(already_found)       // 邩`FbN
		    pat.single=false;
		else
		    already_found=true;
	    }
	}

	return pat;
    }

    abort();			// ɂ͗Ȃ
}


template <typename T_cache, int N_cache> 
class value_cache {
    int idx2frame[N_cache];
    int MRUorder[N_cache];
    T_cache cacheval[N_cache];
    T_cache empty;

    // wt[݂Ԃ
    int to_idx (int frno) const {
	for(int idx=0; idx<N_cache; idx++) {
	    if(idx2frame[idx] == frno)
		return idx;
	}

	return -1;
    }

    void drop_by_idx (int idx) {
	// t[ MRU order 𖖔Ɉړ
	int *pos = std::find(MRUorder, MRUorder+N_cache-1, idx2frame[idx]);
	int o = *pos;
	memmove(pos, pos+1, N_cache-(pos+1-MRUorder));
	MRUorder[N_cache-1]=o;

	// t[̓e
	idx2frame[idx] = -1;
	cacheval[idx] = empty;
    }

    int drop_and_alloc (int newfrno) {
	// gpLbVT
	for(int idx=0; idx<N_cache; idx++) {
	    if(idx2frame[idx] == -1) {
		idx2frame[idx] = newfrno;
		return idx;
	    }
	}

	// gpLbVȂ̂ōłgpĂȂt[
	int oldfr = MRUorder[N_cache-1];// łÂt[
	int idx = to_idx(oldfr);

	idx2frame[idx] = newfrno;		// o^
	cacheval[idx] = empty;

	return idx;
    }

    
    bool update_MRUorder (int frno) {
#if 0
	std::ofstream ofs(LOG_PATH "log.txt", std::ios_base::out | std::ios_base::app);
#endif
	int *pos = std::find(MRUorder, MRUorder+N_cache-1, frno);
	// MRU ̍Ō̈O܂ŒlTB܂łɖ΁AŌ̈
	// ǂȒl낤ƂdȂB

	if(pos == MRUorder)	// łɓɂ
	    return true;

#if 0
	ofs << "update_mru_order: ";
	for(int i=0; i<N_cache; i++)
	    ofs << MRUorder[i] << " ";
#endif	

	// 擪J
	memmove(MRUorder+1, MRUorder, (pos-MRUorder)*sizeof(*MRUorder));

	MRUorder[0] = frno;

#if 0
	ofs << "-> ";
	for(int i=0; i<N_cache; i++)
	    ofs << MRUorder[i] << " ";
	ofs << std::endl;
#endif

	return true;
    }


public:
    value_cache (T_cache emptyval = T_cache()) : empty(emptyval)
    {for(int i=0; i<N_cache; i++) {idx2frame[i]=-1; MRUorder[i]=-1;}}

    bool is_exist (int frno) const {return to_idx(frno) != -1; }

    T_cache & operator [] (int fr) {
	int idx = to_idx(fr);
	if(idx == -1) {
	    idx = drop_and_alloc(fr);
	}

	update_MRUorder(fr);

	return cacheval[idx];
    }

    void clear (void) {
	for(auto & i : MRUorder)
	    i = -1;
	for(auto & i : idx2frame)
	    i = -1;
	for(auto & i : cacheval)
	    i = empty;
    }

    class iterator;

    iterator iter (int frno);
};

template <typename T_cache, int N_cache> 
class value_cache<T_cache, N_cache>::iterator {
    value_cache<T_cache, N_cache> *parent;
    int curfr;
public:
    iterator (value_cache<T_cache, N_cache> *par, int fr)
	: parent(par), curfr(fr) {}

    int frame (void) const { return curfr; }

    T_cache & operator [] (int frno) {
	return (*parent)[curfr+frno];
    }

    T_cache & operator * (void) {
	return (*parent)[curfr];
    }

    iterator & operator ++ () { ++curfr; return *this; }
    bool operator == (iterator const & i) const { return parent == i.parent && curfr == i.curfr; }
    bool operator != (iterator const & i) const { return ! ((*this) == i); }
};

template <typename T_cache, int N_cache> 
typename value_cache<T_cache, N_cache>::iterator value_cache<T_cache, N_cache>::iter (int frno) 
{ return iterator(this, frno); }


class dropcache {
    static const int n_cachewidth=11;

public:
    // Qƒl͐ frame number 
    value_cache<YC_ptr, n_cachewidth> pYC;
    std::map<int, double> sqsumcache;	// Mean square error (noise power)
    std::map<int, double> ppcache;		// Peak error value
    std::map<int, double> signalcache;	// Mean square signal (sig. power)
    std::map<int, double> ssimcache;		// SSIM
    std::map<int, char>  picdiff_cache;	// 0: same frame, 1: differ frame
//    value_cache<bool, n_cachewidth> cachefr; // ̃t[LbVĂ邩?

    typedef decltype(pYC) pYC_type;
    typedef decltype(sqsumcache) stat_type;
    typedef decltype(picdiff_cache) picdiff_type;

    // ׂẴXe[^X݂邩?
    bool stat_exist (int frno) const {
	return sqsumcache.find(frno) != sqsumcache.end()
	    && ppcache.find(frno) != ppcache.end()
	    && signalcache.find(frno) != signalcache.end()
	    && ssimcache.find(frno) != ssimcache.end()
	    && picdiff_cache.find(frno) !=  picdiff_cache.end();
    }

    // ׂĂ̍񂪑݂邩?
    bool diff_exist (int frno) const {
	return sqsumcache.find(frno) != sqsumcache.end()
	    && ppcache.find(frno) != ppcache.end()
	    && signalcache.find(frno) != signalcache.end()
	    && ssimcache.find(frno) != ssimcache.end();
    }

    void clear (void) {
	pYC.clear();
	sqsumcache.clear();
	ppcache.clear();
	signalcache.clear();
	ssimcache.clear();
	picdiff_cache.clear();
    }

    void require_oncache (int frame, FILTER *fp, void *editp) {
#ifdef DEBUG_CACHE
	std::ofstream ofs(LOG_PATH "log.txt", std::ios_base::app);
#endif
	if(!pYC.is_exist(frame)) {
	    YC_ptr tmp(load_source_to_PIXEL_YC( frame, fp, editp));
	    pYC[frame]=tmp;

#ifdef DEBUG_CACHE
	    ofs << "dropcache(fr=" << frame <<"): loading " << std::endl;
#endif
	} else {
	    pYC[frame]; // cache MRU ʂグ
#ifdef DEBUG_CACHE
	    ofs << "dropcache(fr=" << frame <<"): already loaded" << std::endl;
#endif
	}
    }

};

static dropcache cache;

void clear_droplists (void)
{
    droplist.clear();
    sqsumlist.clear();
    ssimlist.clear();
    scrolllist.clear();
    paniclist.clear();
    cache.picdiff_cache.clear();
    return;
}

void clear_allstats (void)
{
    clear_droplists();
    cache.clear();
}


// t[hbv֐
// u24/30vfr or 24fpsvpB30fps->20,15,12,10ɂ͎gpłȂ
static int drop_checker (FILTER *fp, void *editp, int saveno, int frame, 
			 int edit_flag, int interace, dropcache &cache)
{
    dbprintf("%p: dropper(%p, %p, %d, %d, 0x%X, %d, %p) called\n",
	     drop_checker, fp, editp, saveno, frame, edit_flag, interace, &cache);

#if defined(DEBUG_CACHE) || defined(DEBUG_DROP)
    std::ofstream ofs(LOG_PATH "log.txt", std::ios_base::out | std::ios_base::app);
#endif
    int const frsetlen = 5;	// 30f -> 24f

    // 摜r
    int fr = saveno - (saveno % frsetlen);
    int frametop = frame-saveno+fr;

    // fr ... saveԍŕ\錻݂24ft[Jn_
    // frametop ... frameԍŕ\錻݂24ft[Jn_

#ifdef TRAIN
    std::ofstream ofs_train_same("train_same.txt",std::ios_base::app);
    std::ofstream ofs_train_all("train_all.txt", std::ios_base::app);
#endif
//		int lastfr=0;	// Xɕω摜蓦Ȃ悤
//						// ωȂ肵Ât[𔻒Ɏg

    dbprintf("drop_checker: check\n");

    for(int i=0; i<frsetlen*2; i++) {
	if(!cache.stat_exist(frametop+i)) {
#ifdef DEBUG_CACHE
	    ofs << "drop_checker(fr=" << frame <<"): checking pXY: fr(" << frametop+i <<"):"
		<< (cache.pYC.is_exist(frametop+i+1) ? "1" : "0") 
		<< ", fr(" << frametop+i <<"):" << (cache.pYC.is_exist(frametop+i) ? "1" : "0")
		<< std::endl;
#endif

	    if(gband.u()<0) {
		gband.set(last_info.w, last_info.h);
	    }

	    if(!cache.diff_exist(frametop+i)) {
		dbprintf("drop_checker: diffpict %d+%d\n",frametop, i);

		cache.require_oncache(frametop+i, fp, editp);
		cache.require_oncache(frametop+i+1, fp, editp);

		diffpict(cache.sqsumcache[frametop+i], cache.ppcache[frametop+i], // 摜vZ
			 cache.signalcache[frametop+i], cache.ssimcache[frametop+i],
			 cache.pYC[frametop+i], cache.pYC[frametop+i+1], 
			 gband.l(), gband.u(), last_info.w-gband.r(), last_info.h-gband.d(),
			 last_info.max_w, last_info.max_h);
		
	    }

#ifdef TRAIN
	    // training(S摜): Sfr̍p[^
	    ofs_train_all << frame-saveno+fr+i << " "
			  << cache.sqsumcache[frametop+i] << " "
			  << cache.ppcache[frametop+i] << " " 
			  << cache.signalcache[frametop+i] << " "
			  << cache.ssimcache[frametop+i] << std::endl;

	    // training(摜): 
	    // gp@:t[ԍ 1223456678... ƂȂ悤 24f 摜𐮗񂳂ďo
	    if(((frame-saveno+fr+i) % 5) == 1)
		ofs_train_same << frame-saveno+fr+i << " "
			       << cache.sqsumcache[frametop+i] << " " 
			       << cache.ppcache[frametop+i] << " " 
			       << cache.signalcache[frametop+i] << " "
			       << cache.ssimcache[frametop+i] << std::endl;
#endif

	    

	    dbprintf("drop_checker: memo\n",frametop, i);
	    if(cache.sqsumcache[frametop+i] < conf.sqsumlim1())
		sqsumlist[fr+i] = '=';
	    else if(cache.sqsumcache[frametop+i] >= conf.sqsumlim2())
		sqsumlist[fr+i] = '|';
	    else
		sqsumlist[fr+i] = '?';

	    if(cache.ssimcache[frametop+i] < conf.ssimlim()) {
		ssimlist[fr+i] = '|';
	    } else { 
		ssimlist[fr+i] = '=';
	    }

	    dbprintf("drop_checker: judge\n",frametop, i);
	    // 摜ωo
	    char const *evidence_mode;
	    char evidence_judge;
	    if(cache.sqsumcache[frametop+i] < conf.sqsumlim1()) {
		evidence_mode="sqsum(=)";
		evidence_judge=0;
	    } else 
	    if(cache.sqsumcache[frametop+i] >= conf.sqsumlim2()) {
		    evidence_mode="sqsum(|)";
		    evidence_judge=1;
	    } else 
	    if(cache.ssimcache[frametop+i] < conf.ssimlim()) {
		evidence_mode="ssim(|)";
		evidence_judge=1;
	    } else { 
		evidence_mode="ssim(=)";
		evidence_judge=0;

		// XN[
		if(conf.detect_finescroll()) {
		   dbprintf("drop_checker: scroll_detect\n");

		   cache.require_oncache(frametop+i, fp, editp);
		   cache.require_oncache(frametop+i+1, fp, editp);

		   if(scroll_detect(             // + XN[`FbN
			  cache.pYC[frametop+i], cache.pYC[frametop+i+1], 
			  0, 0, last_info.w, last_info.h,
			  last_info.max_w, last_info.max_h)) {
		       evidence_mode="scroll(|)";
		       evidence_judge=1;
		       scrolllist[fr+i]='*';
		   } else {
		       scrolllist[fr+i]='=';
		   }
		}
	    }
//	    ofs<<"[W"<<frametop+i<<"="<<(int)evidence_judge;
	    cache.picdiff_cache[frametop+i] = evidence_judge;
//	    ofs<<"="<<(int)cache.picdiff_cache[frametop+i]<<"]";

#ifdef DEBUG_DROP
	    ofs << "sv"<<saveno <<" frame"<<fr+i-saveno+frame 
		<< ", sqsum" << cache.sqsumcache[frametop+i]
		<< ", pp" << cache.ppcache[frametop+i]
		<< ", sqsig" << cache.signalcache[frametop+i]
		<< ", ssim" << cache.ssimcache[frametop+i]
		<< ", picdiff" << (int)cache.picdiff_cache[frametop+i] 
		<< ", evidence:" << evidence_mode 
//		<< ", chk1:" 
//		<< (int)cache.picdiff_cache[frametop+1] 
//		<< (int)cache.picdiff_cache[frametop+6] 
		<< std::endl;
#endif
	    if(i<frsetlen)
		droplist[fr+i] = 0;		// droplist (͈͊O͏Ȃ)
	} else {
	    // gcc̏ȂƂ 4.5~4.7.2ɂoO悯R[h
	    volatile static int ctr_diff = 0;
	    ctr_diff += cache.picdiff_cache[frametop+i];
	}
    }

    // Aő̃t[hbv
    char picdiff_pat[frsetlen+1];
    char picdiff_pat2[frsetlen+1];
    char picdiff_pat_merge[frsetlen+1];
    for(int i=0; i<frsetlen; i++) {	// LbV̒lzɋl߂
	// ̃p^[
//	ofs<<"[R"<<frametop+i<<"="<<(int)cache.picdiff_cache[frametop+i]<<"]";
	picdiff_pat[i] = cache.picdiff_cache[frametop+i];
	picdiff_pat2[i] = cache.picdiff_cache[frametop+i];

	// 㑱t[Ƃ or ɂp^[𐄑(XN[Jn̞B})
	picdiff_pat_merge[i] = cache.picdiff_cache[frametop+i] | cache.picdiff_cache[frametop+frsetlen+i];
    }

    pict_pattern_t pat_simple = find_pattern(picdiff_pat);
    pict_pattern_t pat_merge = find_pattern(picdiff_pat_merge);
    int drop_pos = -1;

    // [U[ drop wꍇ drop ɋ
    int force_drop_pos = -1;
    for(int i=0; i<frsetlen && force_drop_pos == -1; i++) {
	FRAME_STATUS fst;
	if(fp->exfunc->get_frame_status(editp, frametop+i, &fst) == FALSE)
	    force_drop_pos = -2;

	if((fst.edit_flag & EDIT_FRAME_EDIT_FLAG_DELFRAME) != 0) {
	    force_drop_pos = i;
	    break;
	}
    }

#ifdef DEBUG_DROP
    ofs << "sv" << saveno<<", fr"<<frame<<": ";
#endif

    pict_pattern_t pat;
    char *picdiff_used;

    dbprintf("drop_checker: decide droppos\n");

    if(pat_merge.n_ren == 2 && pat_merge.single) {
    	pat = pat_merge;	// 1ӏȂ΂̗p
	picdiff_used = picdiff_pat_merge;
    } else {
	pat = pat_simple;
	picdiff_used = picdiff_pat;
    }

    int lastdropok=4;	// fr.4 ͕KԈ

    if(force_drop_pos != -1) {	// [U[ɂhbvw肪΋hbv
	drop_pos = force_drop_pos;
	droplist[fr+drop_pos]=true;
    } else if(pat.n_ren > 1) {
	// hbv\t[(̑O4frɊԈꂽfrȂ)T
	for(int i=3; i>=0; i--) {
	    if(fr+i-4>=0 && droplist[fr+i-4]==true)
		break;
	    else
		lastdropok=i;
	}

#ifdef DEBUG_DROP
	ofs << "lastdropok=" << lastdropok << ", npos=" << pat.n_pos
	    << ", npos+npat-1=" << pat.n_pos+pat.n_ren-1 ;

	ofs << ", droppos=" << drop_pos 
	    << ", cond1="<< (pat.n_pos>=lastdropok)
	    << ", cond2="<< (pat.n_pos+pat.n_ren-1<lastdropok);
#endif

	// drop\ȍőOdropframe߂

        // ۑ܂͎݂ (AD悷ꍇ)
	if(conf.keep_droppoint_strongly() && ( 
	       picdiff_used[lastdropok]== 0 
	       || (lastdropok>0 && picdiff_used[lastdropok-1]==0)))
	    drop_pos = lastdropok;
                                   // ݒŖɂĂAȉ̔ lastdropok  
                                   // ŏɊmFĂ̂ŁAADxxႭȂ邾
                                   // ۑ݂铮͕ۑB
	else {
	    // 1. ő咷 2fr Ȃ΁Äv_肤̂őST
	    if(pat.n_ren == 2) {

		if(lastdropok==0 && picdiff_pat[0]==0
		   && (frametop-1>0 && cache.picdiff_cache[frametop-1] == 0)) {
		    drop_pos=4; // Zbg̍ŏƑOZbg̍ŌオȂĂꍇA 
				// A 3 ȏȂ̂ŁAZbg̍ŏOhbvfr
				// 4frȏ㗣Ă΂g
		}

		if(drop_pos == -1 &&picdiff_pat[4]==0 && picdiff_pat2[0]==0) {
		    drop_pos=4;	// Zbg̍ŌƎZbg̍ŏȂĂꍇA
				// A 3 ȏȂ̂łgB
		}

		if(drop_pos == -1) {
		    for(int i=lastdropok; i<5; i++) {
			if(picdiff_used[i]== 0 
			   || (i>0 && picdiff_used[i-1]==0)) {
			    drop_pos = i; // Õhbv4frȏJĂʒuT
			    break;
			}
		    }
		}
		if(drop_pos == -1) { // ł_Ȃł邾̈ʒuT
		    for(int i=lastdropok-1; i>=0; i--) {
			if(picdiff_used[i]== 0 
			   || (i>0 && picdiff_used[i-1]==0)) {
			    drop_pos = i;
			    break;
			}
		    }
		}
		assert(drop_pos >= 0); // n_ren>==Ȃ̂ǂ͌͂
	    }

	// 2. ő咷 3fr ȏȂ΁Äv_͂肦ȂɁApicdiff=0łԈĂ͂Ȃ
	//    fr 肤̂ŁAvZŏoB(헪͓)
	if(pat.n_ren>2) {
	    drop_pos =  (pat.n_pos >= lastdropok) ? pat.n_pos : // S͈ drop
		((pat.n_pos+pat.n_ren-1 < lastdropok) ? (pat.n_pos+pat.n_ren-1) // S͈drops
		 : lastdropok);
	}
    }
    
	droplist[fr+drop_pos]=true;
    } else
	drop_pos = -1;	// drop Ȃ

    for(int i=0; i<5; i++)
	droplist[fr+i];	// ݒ droppos  0 ɂ (map Ȃ̂ŃANZXŗǂ)

#ifdef DEBUG_DROP
	ofs << ", forcedroppos=" << force_drop_pos
	    << ", droppos=" << drop_pos;
#endif

#ifdef DEBUG_DROP
	    ofs << ", pat=(" << pat.n_ren << "," << pat.n_pos << ")"
		<< ", diffpp="<<cache.ppcache[frame]<<", diffsum=" 
		<< cache.sqsumcache[frame] 
		<< ", picdiff_simple=" 
		<< (int)picdiff_pat2[0] << (int)picdiff_pat2[1] 
		<< (int)picdiff_pat2[2] << (int)picdiff_pat2[3] 
		<< (int)picdiff_pat2[4]
		<< ", picdiff_merged=" 
		<< (int)picdiff_pat_merge[0] << (int)picdiff_pat_merge[1] 
		<< (int)picdiff_pat_merge[2] << (int)picdiff_pat_merge[3] 
		<< (int)picdiff_pat_merge[4]
		<< ", picdiff_used=" 
		<< (int)picdiff_used[0] << (int)picdiff_used[1] 
		<< (int)picdiff_used[2] << (int)picdiff_used[3] 
		<< (int)picdiff_used[4]
		<< ", droppat=" << droplist[fr+0] << droplist[fr+1] << droplist[fr+2] 
		<< droplist[fr+3] << droplist[fr+4] 
		<< ", droppos=" <<  drop_pos << "+" << fr 
		<< std::endl;
#endif

    dbprintf("drop_checker: return %d\n",drop_pos);

    return drop_pos;
}



// hbvt[Ԃ֐: TRUE: ۑt[, FALSE: hbvt[
// u24/30vfr or 24fpsvp
static BOOL dropper (FILTER *fp, void *editp, int saveno, int frame, 
		     bool force_drop, int edit_flag, int interace)
{
    int const frsetlen = 5;	// 30f -> 24f

    int fr = saveno - (saveno % frsetlen);
    int frametop = fr - saveno + frame;
    int droppos = -1;
    bool dropnotchecked = false;

    dbprintf("%p: dropper(%p, %p, %d, %d, %d, 0x%X, %d) called\n",
	    dropper, fp, editp, saveno, frame, force_drop, edit_flag, interace);


    // preloader: 摜ǂݍ݂炩ɂ
    if(!cache.diff_exist(frame+8)) {
	cache.require_oncache(frame+8, fp, editp);
	cache.require_oncache(frame+9, fp, editp);
	if(gband.u()<0) {
	    gband.set(last_info.w, last_info.h);
	}
	
	diffpict(cache.sqsumcache[frame+8], cache.ppcache[frame+8], // 摜vZ
		 cache.signalcache[frame+8], cache.ssimcache[frame+8],
		 cache.pYC[frame+8], cache.pYC[frame+9], 
		 gband.l(), gband.u(), last_info.w-gband.r(), last_info.h-gband.d(),
		 last_info.max_w, last_info.max_h);
		
    }

    // droplist ɋL^Ă邩?
    for(int i=0; i<frsetlen; i++) {
	if(droplist.find(fr+i) == droplist.end())
	    dropnotchecked = true;
	else if(droplist[fr+i]) {
	    droppos=i;
	    break;
	}
    }

    dbprintf("dropper: dropchk\n");
    // droplist ɂȂΔ
    if(dropnotchecked)
	droppos = drop_checker(fp, editp, saveno, frame, edit_flag, interace,
			       cache);

    dbprintf("dropper: panic_drop\n");


    // pjbNhbv:
    decltype(droppos) panicpos = -1;
    /* ۑꍇO̎o */
    if(droppos == -1 && conf.keep_droppoint_onpanic()) {
	/* ܂ÕhbvXgT */
	for(auto i=-frsetlen; i<0; i++) {
	    try {
		if(droplist.at(fr+i) == 1) {
		    panicpos = i+frsetlen;
		    paniclist[fr+frsetlen+i] = 'x';
		    break;
		}
	    } catch (std::out_of_range &r) {/* NO operation */}
	}

	/* łȂΒÕpjbNhbvT */
	if(panicpos == -1) {
	    for(auto i=-frsetlen; i<0; i++) {
		try {
		    if(paniclist.at(fr+i) == 'x') {
			panicpos = i+frsetlen;
			paniclist[fr+frsetlen+i] = 'x';
			break;
		    }
		} catch (std::out_of_range &r) {/* NO operation */}
	    }
	}
    }

    // 24fps drop ₪ȂꍇA
    // MSE ̍ŏ̃t[I (vfr droplist ɂ͔fȂ)
    if(droppos == -1 && panicpos == -1) {
	dropcache::stat_type::iterator const pos 
	    = std::min_element(cache.sqsumcache.find(frametop+0), 
			       ++cache.sqsumcache.find(frametop+4), 
			       [](decltype(*pos) i, decltype(*pos) j)->bool 
			          {return i.second<j.second;});
	paniclist[pos->first-frametop+fr] = 'x';
	panicpos = pos->first-frametop;
    }

    if(droppos == -1 && force_drop) {
	assert(panicpos != -1);
	droppos = panicpos; // 24f̂ݎۂɓKp
    }

    dbprintf("dropper: debugout log.txt\n");
#ifdef DEBUG
    std::ofstream ofs(LOG_PATH "log.txt", std::ios_base::out | std::ios_base::app);
    ofs << "sv" << saveno<<", fr"<<frame<<": force_drop=" << force_drop
	<< ", droppos=" << droppos;

    if(dropnotchecked == false)
	ofs << "(cached)";			// check ς݂?

    ofs << ", hantei=" <<  (fr+droppos == saveno ? 1 : 0) 
	<< std::endl;
#endif

    dbprintf("dropper: return\n");

    if(fr+droppos == saveno)
	return FALSE;
    else
	return TRUE;
}

// hbvXg̎w肳ꂽ͈͂ afs Vtgp^[ɕϊ 
static BOOL drop_update (FILTER *fp, void *editp, int saveno, int frame, 
			 bool force_drop, int edit_flag, int interace) {
    unsigned char afspat = 0x30;

    BOOL ldrop[5];

    for(int i=-2; i<3; i++) {
	if(frame+i<0) {
	    ldrop[i+2] = FALSE;
	} else {
	    ldrop[i+2] = dropper (fp, editp, saveno+i, frame+i, force_drop, 
			      edit_flag, interace);
	}
    }

    if(ldrop[0] == FALSE || ldrop[1] == FALSE)
	afspat |= 1;
    if(ldrop[1] == FALSE || ldrop[2] == FALSE)
	afspat |= 2;
    if(ldrop[2] == FALSE || ldrop[3] == FALSE)
	afspat |= 4;
    if(ldrop[3] == FALSE || ldrop[4] == FALSE)
	afspat |= 8;

    // Z[uJn㏉߂Ẵt[ afs Jn
    if(issaving && conf.use_afsvfr() && ! afsout.isopen()) {
	if(afsout.create()) {
	    afsout.set_init(savetop, savebot);
	} else {
	    MessageBox(0, "Failed to initalise afs-server.\n"
		       "Continue working without afs vfr mode.",
		       "[auf] auto2422drop", MB_OK);
	}
    }

    afsout.set_shift(frame, afspat);
#ifdef DEBUG_AFS
    std::ofstream ofs(LOG_PATH "log.txt", std::ios_base::out | std::ios_base::app);
    ofs << "drop_update: afs: fr=" << frame << ", pat=" << std::hex << std::showbase
	<< (int)afspat << std::dec << std::endl;
#endif
    return TRUE;
}

// hbv̕\
static void show_drop_state(FILTER *fp, FILTER_PROC_INFO *fpip, int saveno, int frame, 
		     bool force_drop, int edit_flag, int interace)
{

    if(conf.show_judge() == false || fp->exfunc->is_saving(fpip->editp) == TRUE)
	return;			// \ȂۑȂ画͕\Ȃ

    int const frsetlen = 5;	// 30f -> 24f
    int fr = saveno - (saveno % frsetlen);
    int frametop = frame-saveno+fr;
    // fr ... saveԍŕ\錻݂24ft[Jn_
    // frametop ... frameԍŕ\錻݂24ft[Jn_
    int const xst=32;
    int const yst=32;
    double const transp=0.5;
    int w, h;

    std::stringstream ss[7];
    ss[0] << "MSE   : ";
    ss[1] << "SSIM  : ";
    ss[2] << "SCROLL: ";
    ss[3] << "DROP  :";
    ss[4] << "PANIC : ";
    ss[5] << "USER  : ";

    // dbprintf("Limit: sqsum=[%g, %g] ssim=%g\n", conf.sqsumlim1(),
    // 	     conf.sqsumlim2(), conf.ssimlim());

    // ݂̃t[}[N
    if(fr-saveno == 0)
	ss[3] << "[";
    else 
	ss[3] << " ";

    for(int i=0; i<5; i++) {
	try {
	    if(droplist.at(fr+i) == 1)
		ss[3] << "x";
	    else
		ss[3] << "o";

	    ss[0] << " " << (sqsumlist[fr+i] == 0 ? ' ' : sqsumlist[fr+i]);
	    ss[1] << " " << (ssimlist[fr+i] == 0 ? ' ' : ssimlist[fr+i]);
	    ss[2] << " " << (scrolllist[fr+i] == 0 ? ' ' : scrolllist[fr+i]);
	    ss[4] << (paniclist[fr+i] == 0 ? ' ' : paniclist[fr+i]) << " ";

	    FRAME_STATUS fst;
	    if(fp->exfunc->get_frame_status(fpip->editp, frametop+i, &fst) == TRUE
		&& (fst.edit_flag & EDIT_FRAME_EDIT_FLAG_DELFRAME) != 0)
		ss[5] << "x ";
	    else
		ss[5] << "  ";

	} catch (std::out_of_range r) {
	    ss[0] << " /";
	    ss[1] << " /";
	    ss[2] << " /";
	    ss[3] << " ";
	    ss[4] << "/ ";
	    ss[5] << "/ "; 	// ͈͊OȂt[Ȃ
	    if(!conf.dont_drop())
	    ss[6] << "except@"<<fr+i << ": " << r.what() << std::endl;
	}

	// ݂̃t[}[N
	if(saveno-fr==i)
	    ss[3] << "]";
	else if(saveno-fr==i+1)
	    ss[3] << "[";
	else
	    ss[3] << " ";
    } 

    // Ss
    for(auto i : {1,2,5,3,4,6})
	ss[0] << std::endl << ss[i].str();

#ifdef DEBUG
//    ss[0] << std::endl << "frame=" << frame << " frametop=" << frametop << " save=" << saveno << " savetop=" << fr << std::endl;

    static int loadno=0;
    ss[0] << loadno++ ;		// ʎZ\
#endif

    HFONT hFixedFont = CreateFont(0, 0, 0, 0, FW_NORMAL, 
			FALSE, FALSE, FALSE, DEFAULT_CHARSET, 
			OUT_RASTER_PRECIS, CLIP_DEFAULT_PRECIS, 
			ANTIALIASED_QUALITY,
			FF_MODERN | FIXED_PITCH, 0);


    // ܂TCY𓾂
    fp->exfunc->draw_text(nullptr, 32, 32, 
			  const_cast<char *>(ss[0].str().c_str()), 255, 255, 255, 0,
			  hFixedFont, &w, &h);

    // wi̋Px𗎂Ƃ
    for(int y=0; y<h; y++) {
	for(int x=0; x<w; x++) {
	    fpip->ycp_edit[(y+yst)*fpip->max_w+xst+x].y *= transp;
	}
    }

    // 
    fp->exfunc->draw_text(fpip->ycp_edit, xst, yst, 
			  const_cast<char *>(ss[0].str().c_str()), 255, 255, 255, 0,
			  hFixedFont, &w, &h);

    DeleteObject(hFixedFont);

    return;
}

// 2422ԈtB^s
AVIUTL_CALLBACK static BOOL func_proc( FILTER *fp, FILTER_PROC_INFO *fpip )
{
    LARGE_INTEGER ctr_freq;
    LARGE_INTEGER ctr_start;
    LARGE_INTEGER ctr_end;

    QueryPerformanceCounter(&ctr_start);
    
    memcpy(&last_info, fpip, sizeof(last_info));
    auto old = conf.set(fp);

    // f[^[h
    load_source(fp, fpip);

    // drop frame vZ
    FRAME_STATUS fst;
    fp->exfunc->get_frame_status(fpip->editp, fpip->frame, &fst);

    if(issaving || !conf.dont_drop())
	drop_update(fp, fpip->editp, fpip->frame - savetop+1, fpip->frame+1,
		    false, 1, fst.edit_flag);

    show_drop_state(fp, fpip, fpip->frame - savetop, fpip->frame,
		    false, 1, fst.edit_flag);

    QueryPerformanceCounter(&ctr_end);
    QueryPerformanceFrequency(&ctr_freq);

#ifdef DEBUG_TIME
    {
	std::ofstream ofs(LOG_PATH "log.txt", std::ofstream::app);

	ofs << "Time(func_proc()): " 
	    << static_cast<double>(ctr_end.QuadPart-ctr_start.QuadPart)/ctr_freq.QuadPart
	    *1000 << "ms" << std::endl;
    }
#endif
    conf.set(old);
    return TRUE;
}

// cfr p drop: TRUE: ۑt[
AVIUTL_CALLBACK static BOOL func_is_saveframe (FILTER *fp, void *editp, int saveno, int frame, int fps, 
			       int edit_flag, int inter) 
{
    FILTER *old = conf.set(fp);
    LARGE_INTEGER ctr_freq;
    LARGE_INTEGER ctr_start;
    LARGE_INTEGER ctr_end;

    if(!issaving && conf.dont_drop()) {
	conf.set(old);
	return TRUE;
    }

    QueryPerformanceCounter(&ctr_start);
    
    dbprintf("%p: func_is_saveframe(%p, %p, %d, %d, %d, 0x%X, %d) called\n",
	    func_is_saveframe, fp, editp, saveno, frame, fps, edit_flag, inter);
    BOOL ret = dropper(fp, editp, saveno, frame, true, edit_flag, inter);

    QueryPerformanceCounter(&ctr_end);
    QueryPerformanceFrequency(&ctr_freq);

#ifdef DEBUG_TIME
    {
	std::ofstream ofs(LOG_PATH "log.txt", std::ofstream::app);

	ofs << "Time(func_is_saveframe()): " 
	    << static_cast<double>(ctr_end.QuadPart-ctr_start.QuadPart)/ctr_freq.QuadPart
	    *1000 << "ms" << std::endl;
    }
#endif

    conf.set(old);
    return ret;
}
